## mingw-w64-quarter-1.2.3-1.src.tar.zst

=== src/examples/CMakeLists.txt ===
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

# Minimal example
add_executable(Example minimal.cpp)
target_link_libraries(Example PUBLIC Quarter)

# Dynamic UI Loader example
add_executable(DynamicUILoaderExample dynamicui.cpp quarterviewer.qrc)
target_link_libraries(DynamicUILoaderExample PUBLIC Quarter)

# Direct UI loader example
add_executable(DirectUILoaderExample directui.cpp QuarterViewer.ui)
target_link_libraries(DirectUILoaderExample PUBLIC Quarter)

# Examiner example
add_executable(ExaminerExample examiner.cpp quarterviewer.qrc)
target_link_libraries(ExaminerExample PUBLIC Quarter)

# Inherit UI example
add_executable(InheritUIExample inheritui.cpp
  QuarterViewer.cpp
  QuarterViewer.h
  QuarterViewer.ui
)
target_link_libraries(InheritUIExample PUBLIC Quarter)

# Multiple document interface example
add_executable(MDIExample mdi.cpp
  MdiMainWindow.cpp
  MdiMainWindow.h
  MdiQuarterWidget.cpp
  MdiQuarterWidget.h
)
target_link_libraries(MDIExample PUBLIC Quarter)

# Superimposition example
add_executable(SuperImpositionExample superimposition.cpp)
target_link_libraries(SuperImpositionExample PUBLIC Quarter)

=== src/plugins/CMakeLists.txt ===
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# If this directory is not explicitly included build fails with message "error: Undefined interface"
if(Qt6_FOUND)
  include_directories(${Qt6Designer_INCLUDE_DIRS})
elseif(Qt5_FOUND)
  include_directories(${Qt5Designer_INCLUDE_DIRS})
else()
  include_directories(${QtDesigner_INCLUDE_DIRS})
endif()

# ############################################################################
# Create the QtDesigner plugin
# ############################################################################

add_library(QuarterWidgetPlugin SHARED QuarterWidgetPlugin.cpp QuarterWidgetPlugin.h QuarterWidgetPlugin.qrc coinlogo.qrc)
if(WIN32)
  configure_file(QuarterWidgetPlugin.rc.cmake.in QuarterWidgetPlugin.rc)
  target_sources(QuarterWidgetPlugin PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/QuarterWidgetPlugin.rc")
endif()
target_link_libraries(QuarterWidgetPlugin PUBLIC Quarter ${QUARTER_PLUGIN_QT_TARGETS})

set_target_properties(QuarterWidgetPlugin PROPERTIES VERSION ${QUARTER_VERSION} SOVERSION ${QUARTER_SO_VERSION})

# ############################################################################
# Install the QtDesigner plugin
# ############################################################################

if(QT_PLUGINS_DIR)
  # Legacy FindQt4.
  install(TARGETS QuarterWidgetPlugin
    RUNTIME DESTINATION "${QT_PLUGINS_DIR}/designer"
    LIBRARY DESTINATION "${QT_PLUGINS_DIR}/designer"
  )
else()
  if(Qt6_FOUND)
    # Get qmake location.
    get_target_property(QT_QMAKE_EXECUTABLE Qt6::qmake LOCATION)
  else()
    # Get qmake location.
    get_target_property(QT_QMAKE_EXECUTABLE Qt5::qmake LOCATION)
  endif()
  # Call qmake to query the installation prefix.
  execute_process(COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_INSTALL_PREFIX
    OUTPUT_VARIABLE QT_INSTALL_PREFIX OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  # Call qmake to query the plugin installation directory.
  execute_process(COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_INSTALL_PLUGINS
    OUTPUT_VARIABLE QT_INSTALL_PLUGINS OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  # Compute relative plugin installation directory.
  file(RELATIVE_PATH CMAKE_INSTALL_QTPLUGINSDIR_DEFAULT
    "${QT_INSTALL_PREFIX}" "${QT_INSTALL_PLUGINS}"
  )
  # Set cache variable like in GNUInstallDirs module
  set(CMAKE_INSTALL_QTPLUGINSDIR "${CMAKE_INSTALL_QTPLUGINSDIR_DEFAULT}"
    CACHE PATH "Qt plugins (${CMAKE_INSTALL_QTPLUGINSDIR_DEFAULT})"
  )
  install(TARGETS QuarterWidgetPlugin
    RUNTIME DESTINATION "${CMAKE_INSTALL_QTPLUGINSDIR}/designer" COMPONENT development
    LIBRARY DESTINATION "${CMAKE_INSTALL_QTPLUGINSDIR}/designer" COMPONENT development
  )
endif()

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.su>

_realname=quarter
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.2.3
pkgrel=1
pkgdesc="Coin GUI binding for Qt (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.coin3d.org/Quarter/html/'
msys2_repository_url='https://github.com/coin3d/quarter'
license=('BSD')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-graphviz"
             "${MINGW_PACKAGE_PREFIX}-doxygen"
             "${MINGW_PACKAGE_PREFIX}-qt6-tools")
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-coin"
         "${MINGW_PACKAGE_PREFIX}-qt6-base")
optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-tools: Designer plugin")
options=('!strip' '!buildflags')
source=("${msys2_repository_url}/archive/v${pkgver}/quarter-${pkgver}.tar.gz")
sha256sums=('e78ceaafbc319267e6391183afe1f81b773f840608b1573b7eff5b7ea9d46b90')

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -G"MSYS Makefiles" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_BUILD_TYPE=Release \
    -DQUARTER_BUILD_PLUGIN=ON \
    -DQUARTER_BUILD_EXAMPLES=OFF \
    -DQUARTER_BUILD_DOCUMENTATION=ON \
    -DQUARTER_USE_CPPFLAGS=-DQUARTER_DLL \
    ../quarter-${pkgver}

  cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" cmake --install .

  install -Dm644 "${srcdir}/quarter-${pkgver}/COPYING" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}

# vim:set ts=2 sw=2 et:
